<?php
/*
Plugin Name: Quick'n'Dirty
Plugin URI: http://www.burnmind.com/howto/how-to-build-a-quick-n-dirty-wordpress-plugin
Version: v1.00
Author: <a href="http://www.burnmind.com/">burnmind.com</a>
Description: A Quick'n'Dirty WordPress plugin
 */

if (!class_exists("qnd"))
{
    class Qnd
    {
        private $wpdb;
        private $qndTable;

        public function __construct ()
        {
            global $wpdb;
            $this->wpdb = $wpdb;
            $this->qndTable = $wpdb->prefix . "qnd";
        }

        function createTable()
        {
            if($this->wpdb->get_var("show tables like '$this->qndTable'") != $this->qndTable)
            {
                $create =   "CREATE TABLE " . $this->qndTable . " (
                            id int(20) NOT NULL AUTO_INCREMENT,
                            name varchar(300) NOT NULL,
                            email varchar(300) NOT NULL,
                            location varchar(300) NOT NULL,
                            PRIMARY KEY (id)
                            ) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1; ";

                require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
                dbDelta($create);
            }
        }

        function controler()
        {
            if (isset($_POST['nameField']))
            {
                return $this->submitDetails();
            }
            else
            {
                return $this->displayForm(false);
            }
        }

        function displayForm($error)
        {
        ?>
            <p>Please complete the form to send you the e-book when it's published.</p>
            <?php if ($error) { ?>
                <p style="color:#FF0000;"><strong>Please complete all the required fields!</strong></p>
            <?php } ?>
            <form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>">
                    <ul>
                        <li>
                            <label>Name:</label><br /> <input type="text" name="nameField" value="<?php echo $_POST['nameField'] ?>" /> (required)
                        </li>
                        <li>
                            <label>E-mail:</label><br /> <input type="text" name="emailField" value="<?php echo $_POST['emailField'] ?>" /> (required)
                        </li>
                        <li>
                            <label>Location:</label><br /> <input type="text" name="locationField" value="<?php echo $_POST['locationField'] ?>" />
                        </li>
                    </ul>
                <input type="submit" value="Submit" onclick="return validate()" />
            </form>
        <?php
        }

        function submitDetails()
        {
            $name = $this->wpdb->escape($_POST['nameField']);
            $email = $this->wpdb->escape($_POST['emailField']);
            $location = $this->wpdb->escape($_POST['locationField']);
			
            if($name=='' || $email=='')
            {
				$this->displayForm(true);
            }
            else
            {
                $insert = "INSERT INTO $this->qndTable
                           (name, email, location)
                           VALUES ('$name', '$email', '$location')";

                           $this->wpdb->query($insert);
                           echo 'Your details have been submitted. Thank you!';
            }
        }
    }
}

if (class_exists("qnd"))
{
    $qnd = new Qnd();
}

if (isset($qnd))
{
    add_shortcode('QUICKNDIRTY', array( &$qnd, 'controler'));
    register_activation_hook(__FILE__, array(&$qnd, 'createTable'));
}
?>